/***********************************************************

	pic16clcd.c

	Version 0.90: 2009/10/16

	Copyright (C) 2007-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/

/*******************************************************//**

***********************************************************/

#include "picsys16.h"


#if defined(USE_CLCD)

static byte rsPin, ePin ;
static byte dbPin[4] ;


/*----------------------------------------------------------
	_OutHCLCD():ʃjuLCDW[ɏo
----------------------------------------------------------*/

static void
_OutHCLCD(byte c)	/** @internal */
{
#ifdef OPTIMIZE
#if defined(PIC_DEV_690RL)
    PORTC = (PORTC & 0xf0) | (c >> 4) ;
#elif defined(PIC_DEV_886RL)
    PORTB = (PORTB & 0xe1) | ((c >> 3) & 0x1e) ;
#else
	OPT_SEG1 = (c >> 4) & 1 ;
	NOP() ;
	OPT_SEG2 = (c >> 5) & 1 ;
	NOP() ;
	OPT_SEG3 = (c >> 6) & 1 ;
	NOP() ;
	OPT_SEG3 = (c >> 7) & 1 ;
	NOP() ;
#endif

	OPT_SR_CLK = 1 ;
//	NOP(); NOP(); NOP(); NOP(); NOP();
	delayMicroseconds(1) ;
	OPT_SR_CLK = 0 ;
#else
	char i ;

	for (i = 0; i < 4; i++)
		digitalWrite(dbPin[i], c & BIT(i + 4)) ;

	digitalWrite(ePin, HIGH) ;
	digitalWrite(ePin, LOW) ;
#endif
}


/*----------------------------------------------------------
	_OutBCLCD():oCgf[^LCDW[ɏo
----------------------------------------------------------*/

static void
_OutBCLCD(byte c)
{
#ifdef OPTIMIZE
	OPT_TRIS_SEG1 = 0 ;
	NOP() ;
	OPT_TRIS_SEG2 = 0 ;
	NOP() ;
	OPT_TRIS_SEG3 = 0 ;
	NOP() ;
	OPT_TRIS_SEG4 = 0 ;
	NOP() ;

#if defined(PIC_DEV_690RL)
    PORTC = (PORTC & 0xf0) | (c >> 4) ;
#elif defined(PIC_DEV_886RL)
    PORTB = (PORTB & 0xe1) | ((c >> 3) & 0x1e) ;
#else
	OPT_SEG1 = (c >> 4) & 1 ;
	NOP() ;
	OPT_SEG2 = (c >> 5) & 1 ;
	NOP() ;
	OPT_SEG3 = (c >> 6) & 1 ;
	NOP() ;
	OPT_SEG4 = (c >> 7) & 1 ;
	NOP() ;
#endif

	OPT_SR_CLK = 1 ;
//	NOP(); NOP(); NOP(); NOP(); NOP();
	delayMicroseconds(1) ;
	OPT_SR_CLK = 0 ;

#if defined(PIC_DEV_690RL)
    PORTC = (PORTC & 0xf0) | (c & 0x0f) ;
#elif defined(PIC_DEV_886RL)
    PORTB = (PORTB & 0xe1) | ((c << 1) & 0x1e) ;
#else
	OPT_SEG1 = (c >> 0) & 1 ;
	NOP() ;
	OPT_SEG2 = (c >> 1) & 1 ;
	NOP() ;
	OPT_SEG3 = (c >> 2) & 1 ;
	NOP() ;
	OPT_SEG4 = (c >> 3) & 1 ;
	NOP() ;
#endif
	OPT_SR_CLK = 1 ;
//	NOP(); NOP(); NOP(); NOP(); NOP();
	delayMicroseconds(1) ;
	OPT_SR_CLK = 0 ;
#else
	char i ;
	
	// f[^̏o̓so̓[hɕύX
	for (i = 0; i < 4; i++)
		pinMode(dbPin[i], OUTPUT) ;

	_OutHCLCD(c) ;

	for (i = 0; i < 4; i++)
		digitalWrite(dbPin[i], c & BIT(i)) ;

	digitalWrite(ePin, HIGH) ;
	digitalWrite(ePin, LOW) ;
#endif
}


/***********************************************************
	LCD̏
***********************************************************/

void
CLCD_init(byte rs, byte e, byte seg1, byte seg2, byte seg3, byte seg4)
{
	char i ;
	
	rsPin = rs ;
	ePin = e ;
	dbPin[0] = seg1 ;
	dbPin[1] = seg2 ;
	dbPin[2] = seg3 ;
	dbPin[3] = seg4 ;

	pinMode(rsPin, OUTPUT) ;
	pinMode(ePin, OUTPUT) ;

	digitalWrite(ePin, LOW) ;
// f[^̏o̓so̓[hɕύX
	for (i = 0; i < 4; i++)
		pinMode(dbPin[i], OUTPUT) ;

	delayMilliseconds(20) ;	// LCD̃p[IZbg̑҂ 15msȏ
        
// 4rbgC^[tF[Xɐݒ肷邽߂̏vgR
	_OutHCLCD(CLCD_INTERFACE_8BIT) ;
	delayMilliseconds(5) ;  // 4.1msȏ
	_OutHCLCD(CLCD_INTERFACE_8BIT) ;
	delayMilliseconds(1) ;
	_OutHCLCD(CLCD_INTERFACE_8BIT) ;
	delayMilliseconds(1) ;

// C^[tF[X4rbg
	_OutHCLCD(CLCD_INTERFACE_4BIT) ;	// !! 4bit
	delayMilliseconds(1) ;

// sƃtHg̐ݒ
	CLCD_cmd(CLCD_2LINE) ;

// fBXvC̕\
	CLCD_cmd(CLCD_DISPLAY_OFF) ;
	CLCD_cmd(CLCD_DISPLAY_ON & CLCD_CURSOR_ON & CLCD_BLINK_ON) ;

// Gg[[h̐ݒ
	CLCD_cmd(CLCD_CURSOR_INC) ;
// ȏŏvgRI

	CLCD_cmd(CLCD_CLEAR) ;
}

/***********************************************************
	LCDւ̃R}ho
***********************************************************/

void
CLCD_cmd(byte cmd)
{
	digitalWrite(rsPin, LOW) ;	// R}hWX^̑I

	_OutBCLCD(cmd) ;

	if (cmd < 0x04)	
		delayMilliseconds(2) ;	// ̃R}h͏Ԃ
	else
		delayMicroseconds(40) ;
}


/***********************************************************
	LCDւ̂Po
***********************************************************/

void
CLCD_write(char data)
{
	digitalWrite(rsPin, HIGH) ;	// f[^WX^̑I

	_OutBCLCD(data) ;

	delayMicroseconds(40) ;
}


/***********************************************************
	LCD̃J[\ݒ
***********************************************************/

void
CLCD_setCursor(unsigned char row, unsigned char line)
{
	line *= 0x40 ;
	line += row ;
		
	CLCD_cmd(CLCD_DDRAM_ADDR | line) ;
}


/***********************************************************
	LCDւ(RAM)o
***********************************************************/

void
CLCD_puts(char *s)
{
	while(*s)
		CLCD_write(*s++) ;
}


/***********************************************************
	LCDւ(ROM)o
***********************************************************/

void
CLCD_putrs(const char *s)
{
	while(*s)
		CLCD_write(*s++) ;
}

/***********************************************************
	tւ̐lo
***********************************************************/

void
CLCD_puti(long n)
{
    char *s ;

	ltoa(_fmtbuf, n, 10) ;
	
	s = _fmtbuf ;

	while(*s)
		CLCD_write(*s++) ;
}

/***********************************************************
	tւ̃oCilo
***********************************************************/

void
CLCD_putb(long n, byte base)
{
    char *s ;

	ltoa(_fmtbuf, n, base) ;
	
	s = _fmtbuf ;

	while(*s)
		CLCD_write(*s++) ;
}

#endif
