/***********************************************************

	pic16clcd.h

	Version 0.90: 2009/10/16

	Copyright (C) 2007-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/

/*******************************************************//**
	@file clcd.h
	@brief LCD\퐧䃉Cu
***********************************************************/

#ifndef PIC16CLCD_H__
#define PIC16CLCD_H__


/***********************************************************
	OpenCLCD()̈
***********************************************************/

/*----------------------------------------------------------
	OpenCLCD()̑
----------------------------------------------------------*/

/// \s̎w
#define CLCD_2LINE		0b00101011	///< Qs
#define CLCD_1LINE		0b00100011	///< Ps


/***********************************************************
	CmdCLCD()̈
***********************************************************/

void CLCD_cmd(byte) ;

/// Clear Display
#define	CLCD_CLEAR			0b00000001

/// Cursor At Home
#define	CLCD_HOME			0b00000010

/// Entry Mode
#define	CLCD_CURSOR_INC		0b00000110	///< J[\|C^͑
#define	CLCD_CURSOR_DEC		0b00000100	///< J[\|C^͌

/// Display ON/OFF Control
#define CLCD_DISPLAY_ON		0b00001111	///< \ON
#define CLCD_DISPLAY_OFF	0b00001011	///< \OFF
#define CLCD_CURSOR_ON		0b00001111	///< J[\ON
#define CLCD_CURSOR_OFF		0b00001101	///< J[\OFF
#define CLCD_BLINK_ON		0b00001111	///< J[\uNON
#define CLCD_BLINK_OFF		0b00001110	///< J[\uNOFF

/// Cursor/Display Shift
#define CLCD_SHIFT_DISPLAY_RIGHT	0b00011111	///< \E
#define CLCD_SHIFT_DISPLAY_LEFT		0b00011011	///< \
#define CLCD_SHIFT_CURSOR_RIGHT		0b00010111	///< J[\E
#define CLCD_SHIFT_CURSOR_LEFT		0b00010011	///< J[\

/// Function Set:LCD\̃C^[tF[X̃rbg
#define CLCD_INTERFACE_8BIT		0b00111011	///< Wrbg
#define CLCD_INTERFACE_4BIT		0b00101011	///< Srbg

/// CGRAM Address Set
#define CLCD_CGRAM_ADDR		0b01000000

/// DDRAM Address Set
#define CLCD_DDRAM_ADDR		0b10000000


/***********************************************************
	֐̃vg^Cvу}Ni[֐j̒`
***********************************************************/

void CLCD_init(byte, byte, byte, byte, byte, byte) ;
#if defined(SR_DAT)
#define CLCD_initDefault() CLCD_init(SR_DAT, SR_CLK, SEG1, SEG2, SEG3, SEG4)
#endif

void CLCD_setCursor(unsigned char, unsigned char) ;
void CLCD_write(char) ;

/// LCDւ̂Po
#define CLCD_putc CLCD_write

void CLCD_puts(char *) ;
void CLCD_putrs(const char *) ;
void CLCD_puti(long) ;
void CLCD_putb(long n, byte) ;


///@LCD̉ʏ
#define	CLCD_clear()	CLCD_cmd(CLCD_CLEAR)
/// LCD̃J[\z[|WV(0,0)
#define	CLCD_home()		CLCD_cmd(CLCD_HOME)


#endif /*PIC16CLCD_H_*/
