/***********************************************************

	pic16dml.c
	
	Version 0.90: 2009/10/16

	Copyright (C) 2007-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/

#include "picsys16.h"


#if defined(USE_DML)

static byte refreshDML = 0 ;
static byte dataPin ; // hbg}gbNXLEDp̃VtgWX^̃f[^s
static byte clockPin ; // hbg}gbNXLEDp̃VtgWX^̃NbNs
static byte ePin ; // Jo͂̃Cl[us
static byte dbPin[3] ; // Jo͂̑Is

static byte _gDL = 0 ; //hbg}gbNXLED̃_Ci~bN_̑Ώۍs
/* hbg}gbNXLED̕\f[^i[̈FVRAM̂悤Ȃ*/
static byte _gMXR[8] ; /*  */
#if !defined (PIC_PICO_2S)
static byte _gMXG[8] ; /*  */
#endif

#if defined(PIC_GAME_2SX)
/* hbg}gbNXLED̏ */
void
DML_initDefault()
{
	/* VtgWX^ps̏o͐ݒ */
	TRISA &= 0b11011011 ;

	/* ȒIso͂ */
	TRISB &= 0b11111001 ;
	TRISC &= 0b00000110 ;

	/* RANeBu */
	PORTB &= 0b11111001 ;
	PORTC &= 0b00000110 ;

	DML_clear() ; // ɕ\NA
	
	refreshDML = 1 ;
}

#elif defined(PIC_PICO_2S)

/* hbg}gbNXLED̏ */
void
DML_initDefault()
{
	/* VtgWX^ps̏o͐ݒ */
	TRISB &= 0b11111001 ;

	/* Ro͂ */
	TRISA &= 0b00100000 ;
	TRISB &= 0b11011111 ;

	/* RANeBu */
	PORTA |= 0b11011111 ;
	PORTB |= 0b00100000 ;

	DML_clear() ; // ɕ\NA

	refreshDML = 1 ;
}
#else
/* hbg}gbNXLED̏ */
void
DML_init(byte rs, byte e, byte db4, byte db5, byte db6, byte db7)
{
  /* I/Os̊tpɋL^ */
  dataPin = rs ;
  clockPin = e ;
  dbPin[0] = db4 ;
  dbPin[1] = db5 ;
  dbPin[2] = db6 ;
  ePin = db7 ;
  
  pinMode(dataPin, OUTPUT) ; // VtgWX^ւ̃f[^so͂
  pinMode(clockPin, OUTPUT) ; // VtgWX^ւ̃NbNso͂
  
  /* ȒIsƃCl[uso͂ */
  pinMode(dbPin[0], OUTPUT) ;
  pinMode(dbPin[1], OUTPUT) ;
  pinMode(dbPin[2], OUTPUT) ;
  pinMode(ePin, OUTPUT) ;

  digitalWrite(ePin, LOW) ; // JANeBu
  
  DML_clear() ; // ɕ\NA

	refreshDML = 1 ;
}
#endif

/* hbg}gbNXLED̕\NA */
void
DML_clear()
{
  int i ;

  for (i = 0 ; i < 8 ; i++) {
    _gMXR[i] = 0 ;
#if !defined (PIC_PICO_2S)
    _gMXG[i] = 0 ;
#endif
  }
}


/* hbg}gbNXLEDւ̃vbg */
/* 0:A1:ԁA2:΁A3: */
void
DML_plot(int x, int y, byte color)
{
  byte w ;

  w = (1 << x) ;

  /* hbgf[^̏ */
  switch (0b11 & color) {
    case DML_DOT_BLACK:
      _gMXR[y] &= ~w ;
#if !defined (PIC_PICO_2S)
      _gMXG[y] &= ~w ;
#endif
      break ;
    case DML_DOT_RED:
      _gMXR[y] |= w ;
#if !defined (PIC_PICO_2S)
      _gMXG[y] &= ~w ;
#endif
      break ;
    case DML_DOT_GREEN:
      _gMXR[y] &= ~w ;
#if !defined (PIC_PICO_2S)
      _gMXG[y] |= w ;
#endif
      break ;
    case DML_DOT_ORANGE:
      _gMXR[y] |= w ;
#if !defined (PIC_PICO_2S)
      _gMXG[y] |= w ;
#endif
      break ;
  }
}

#ifdef OPTIMIZE
/* IɌĂяoĕ\XV郁eiX */
/* _Ci~bN\̊jS */
void
isr_DML_update()
{
	char i ;
	byte value ;

	if (refreshDML == 0)
	    return ;
	    
 /* \錅̊mFFӂĂOɏ񂳂 */
	if (_gDL >= 8)
		_gDL = 0 ;

#if defined(PIC_GAME_2SX)
    PORTC &= 0b00000110 ;
    PORTB &= 0b11111001 ;
#elif defined(PIC_PICO_2S)
    PORTA |= 0b11011111 ;
    PORTB |= 0b00100000 ;
#else
	OPT_SEG4 = 0 ; // f[^XVɔRANeBu  
#endif

#if defined (PIC_PICO_2S)
//	isr_optShiftOut(_gMXR[_gDL]) ; // ԐFo
{
    value = _gMXR[_gDL] ;
	for (i = 0; i < 8; i++)  {
		OPT_SR_DAT = (value & 0b10000000) ? 1 : 0 ;
		NOP() ;
		OPT_SR_CLK = 1 ;
		NOP() ;
		OPT_SR_CLK = 0 ;

		value <<= 1 ;
	}
}
#else
//	isr_optShiftOut(_gMXR[_gDL]) ; // ԐFo
{
    value = _gMXR[_gDL] ;
	for (i = 0; i < 8; i++)  {
		OPT_SR_DAT = (value & 0b10000000) ? 1 : 0 ;
		NOP() ;
		OPT_SR_CLK = 1 ;
		NOP() ;
		OPT_SR_CLK = 0 ;

		value <<= 1 ;
	}
}
//	isr_optShiftOut(_gMXG[_gDL]) ; // ΐFo
{
    value = _gMXG[_gDL] ;
	for (i = 0; i < 8; i++)  {
		OPT_SR_DAT = (value & 0b10000000) ? 1 : 0 ;
		NOP() ;
		OPT_SR_CLK = 1 ;
		NOP() ;
		OPT_SR_CLK = 0 ;

		value <<= 1 ;
	}
}
#endif

  /* R̕\s̑I */
#if defined(PIC_GAME_2SX)
	if (_gDL == 1)
    	RB1 = 1 ;
	else if (_gDL == 2)
		RB2 = 1 ;
	else
    	PORTC |= BIT(_gDL) ;
#elif defined(PIC_PICO_2S)
	if (_gDL == 5)
    	RB5 = 0 ;
	else
    	PORTA &= ~BIT(_gDL) ;
#else
  	OPT_SEG1 = (_gDL & 0b001) ? 1: 0 ;
  	OPT_SEG2 = (_gDL & 0b010) ? 1: 0 ;
  	OPT_SEG3 = (_gDL & 0b100) ? 1: 0 ;
  
  	OPT_SEG4 = 1 ;
#endif
	_gDL++ ;
}

#else

/* IɌĂяoĕ\XV郁eiX */
/* _Ci~bN\̊jS */
void
isr_DML_update()
{
	if (refreshDML == 0)
	    return ;

 /* \錅̊mFFӂĂOɏ񂳂 */
	if (_gDL >= 8)
		_gDL = 0 ;

	digitalWrite(ePin, LOW) ; // f[^XVɔRANeBu  

	shiftOut(dataPin, clockPin, MSBFIRST, _gMXR[_gDL]) ; // ԐFo
	shiftOut(dataPin, clockPin, MSBFIRST, _gMXG[_gDL]) ; // ΐFo

  /* R̕\s̑I */
	digitalWrite(dbPin[0], (_gDL & 0b001) ? 1: 0) ;
	digitalWrite(dbPin[1], (_gDL & 0b010) ? 1: 0) ;
	digitalWrite(dbPin[2], (_gDL & 0b100) ? 1: 0) ;

	digitalWrite(ePin, HIGH) ; // RANeBu\ĊJ
  
	_gDL++ ;
}

#endif

#endif
