/***********************************************************

	pic16seg7.c
	
	Version 0.90: 2009/10/16

	Copyright (C) 2007-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/

#include "picsys16.h"


#if defined(USE_SEG7)

static byte refreshSeg7 = 0 ;
static byte datPin, clkPin, swPin = 0xff ;
static byte segDigit[SEG7_DIGITS] ;

/* 7ZOgLED̃_Ci~bN_̑Ώی */
static unsigned char gDL = 0 ;
/* 7ZOgLED̕\f[^i[̈ */
static byte g7SEG[SEG7_DIGITS] ;

/* 7ZOgLED̕\p^[ */
static const byte gPTN[] = {
	0b00111111, /* 0 */
	0b00000110,
	0b01011011,
	0b01001111,
	0b01100110,
	0b01101101,
	0b01111101,
	0b00000111,
	0b01111111,
	0b01100111, /* 9 */
	0b01110111, /* A */
	0b01111100, /* b */
	0b01011000, /* c */
	0b01011110, /* d */
	0b01111001, /* E */
	0b01110001, /* F */
	0b00000000, /*   */
	0b01000000, /* - */
	0b01110110, /* H */
	0b00111000, /* L */
	0b01100011, /* ~ */
	0b01011100, /* _ */
} ;


#if defined(PIC_7SEG_88)
static byte __sw[6] ;
#endif


#if defined(PIC_PICO_3S)

/* VZOgLED̏ */
void
SEG7_initDefault()
{
	/* Rs̏o͐ݒ */
	TRISB &= 0b11111001 ;

	/* ZOgo͂ */
	TRISA &= 0b00100000 ;
	TRISB &= 0b11011111 ;

	/* ZOgANeBu */
	PORTA |= 0b11011111 ;
	PORTB |= 0b00100000 ;

	g7SEG[0] = 0b00000000 ;	// ɕ\NA
	g7SEG[1] = 0b00000000 ;
	
	refreshSeg7 = 1 ;
}

#else

void
SEG7_init(byte dat, byte clk, byte seg1, byte seg2, byte seg3, byte seg4)
{
	char i ;

#if defined(PIC_7SEG_88)
{
	pinMode(SW_ACTIVATE, OUTPUT) ;
	digitalWrite(SW_ACTIVATE, HIGH) ;

	__sw[0] = 0x00 ;
	__sw[1] = 0x00 ;
	__sw[2] = 0x00 ;
	__sw[3] = 0x00 ;
	__sw[4] = 0x00 ;
	__sw[5] = 0x00 ;
}
#endif

	datPin = dat ;
	clkPin = clk ;
	segDigit[0] = seg1 ;
	segDigit[1] = seg2 ;
	segDigit[2] = seg3 ;
	segDigit[3] = seg4 ;

	pinMode(clkPin, OUTPUT) ;
	pinMode(datPin, OUTPUT) ;

	shiftOut(datPin, clkPin, LSBFIRST, 0xff) ;

	for (i = 0; i < SEG7_DIGITS; i++) {
	   pinMode(segDigit[i], OUTPUT) ;
	   digitalWrite(segDigit[i], HIGH) ;
    }
	
	refreshSeg7 = 1 ;
}

#endif


/***********************************************************
	XCb`̏
***********************************************************/

#if defined(PIC_7SEG_88)

void
isr_SW_update()
{
#ifdef OPTIMIZE
/*
	OPT_TRIS_SEG1 = 1 ;
	OPT_TRIS_SEG2 = 1 ;
	OPT_TRIS_SEG3 = 1 ;
	OPT_TRIS_SEG4 = 1 ;
*/
	TRISB |= 0b00110110 ;

	OPT_SW_ACTIVATE = 0 ;

	__sw[0] = OPT_SW1 ;
	__sw[1] = OPT_SW2 ;
	__sw[2] = OPT_SEG1 ;
	__sw[3] = OPT_SEG2 ;
	__sw[4] = OPT_SEG3 ;
	__sw[5] = OPT_SEG4 ;

	OPT_SW_ACTIVATE = 1 ;

/*
	OPT_TRIS_SEG1 = 0 ;
	OPT_TRIS_SEG2 = 0 ;
	OPT_TRIS_SEG3 = 0 ;
	OPT_TRIS_SEG4 = 0 ;
*/
	TRISB &= ~0b00110110 ;

#else
	isr_digitalWrite(SW_ACTIVATE, LOW) ;

	__sw[0] = digitalRead(SW1) ;
	__sw[1] = digitalRead(SW2) ;
	__sw[2] = digitalRead(SEG1) ;
	__sw[3] = digitalRead(SEG2) ;
	__sw[4] = digitalRead(SEG3) ;
	__sw[5] = digitalRead(SEG4) ;

	isr_digitalWrite(SW_ACTIVATE, HIGH) ;
#endif
}


byte
SW_read(byte n)
{
	return __sw[n] & 1 ;
}

#endif


/***********************************************************

***********************************************************/
/* 7ZOgLEDւ1o */
void
SEG7_setDigit(char i, char n)
{
	if (n >= sizeof(gPTN)/sizeof(byte)) {
		/* Ȓl̏ꍇɂ́A */
		g7SEG[(i & (SEG7_DIGITS - 1))] = 0b00000000 ;
	} else {
		/* lɑΉ_p^[̐ݒ */
		g7SEG[(i & (SEG7_DIGITS - 1))] = gPTN[n] ;

		/* 傫ꍇɂ́Ahbgǉ\ */
		if (i >= SEG7_DIGITS)
			g7SEG[(i & (SEG7_DIGITS - 1))] |= 0b10000000 ;
	}
}

#if !defined(PIC_PICO_3S)

/* lS̃f[^Ƃĕ\ */
void
SEG7_write(int n, byte type)
{
	byte sign = FALSE ;
	byte head = SEG7_BLANK ;
	int base2, base3 ;

	if (n < 0) {
		sign = TRUE ;
		head = SEG7_MINUS ;
		n = -n ;
	}

	SEG7_setDigit(3, n % 10) ;

	if (type == SEG7_INT) {
		/* [TvXŕKvłΐ擪Ƀ}CiX\ */
		if (n >= 10) {
			SEG7_setDigit(2, (n / 10) % 10) ;

			if (n >= 100) {
				SEG7_setDigit(1, (n / 100) % 10) ;
				if (n >= 1000) {
					SEG7_setDigit(0, (n / 1000) % 10) ;
				} else {
					SEG7_setDigit(0, head) ;
				}
			} else {
				SEG7_setDigit(1, head) ;
				SEG7_setDigit(0, SEG7_BLANK) ;
			}
		} else {
			SEG7_setDigit(2, head) ;
			SEG7_setDigit(1, SEG7_BLANK) ;
			SEG7_setDigit(0, SEG7_BLANK) ;
		}	
	} else {
		/* type ɂ͊Ă */
		base2 = (int)type * type ;
		base3 = base2 * type ;
		SEG7_setDigit(2, (n / type) % type) ;
		SEG7_setDigit(1, (n / base2) % type) ;
		SEG7_setDigit(0, (n / base3) % type );
	}
}

#else

/* lQ̃f[^Ƃĕ\ */
void
SEG7_write(int n, byte type)
{
	byte sign = FALSE ;
	byte head = SEG7_BLANK ;

	if (n < 0) {
		sign = TRUE ;
		head = SEG7_MINUS ;
		n = -n ;
	}

	SEG7_setDigit(1, n % 10) ;

	if (type == SEG7_INT) {
		/* [TvXŕKvłΐ擪Ƀ}CiX\ */
		if (n >= 10) {
			SEG7_setDigit(0, (n / 10) % 10) ;
		} else {
			SEG7_setDigit(0, head) ;
		}	
	} else {
		/* type ɂ͊Ă */
		SEG7_setDigit(0, (n / type) % type) ;
	}
}

#endif


#ifdef	OPTIMIZE

#ifdef PIC_PICO_3S
/* 7ZOgLED̃_Ci~bN_\ */
/* gDLőΏۂƂȂĂ錅\ */
void
isr_SEG7_update()
{
	char i ;

    if (refreshSeg7 == 0)
        return ;
        
	/* \錅̊mF */
    if (gDL >= SEG7_DIGITS)
		gDL = 0 ;

	/* RׂĔANeBu */
	PORTB |= 0b00000110 ;

	/* 1̕\f[^(ANeBuEj̏o */
	PORTA = (0b11111 & ~g7SEG[gDL]) | ((0b01100000 & ~g7SEG[gDL]) << 1) ;
	RB5 = (g7SEG[gDL] & 0b10000000) ? 0 : 1 ;

	/* ỸRANeBu */
	switch (gDL++) {
		case 0:
			OPT_CMN1 = 0 ;
			break ;
		case 1:
			OPT_CMN2 = 0 ;
			break ;
	}
}

#elif defined(PIC_7SEG_88)

/* 7ZOgLED̃_Ci~bN_\ */
/* gDLőΏۂƂȂĂ錅\ */
void
isr_SEG7_update()
{
	char i ;
	byte data ;
	
    if (refreshSeg7 == 0)
        return ;
        
	/* \錅̊mF */
    if (gDL >= SEG7_DIGITS)
		gDL = 0 ;

	/* RׂĔANeBu */
	PORTB |= 0b00110110 ;

//	isr_optShiftOut(0xff) ;
{
    data = 0xff ;
	for (i = 0; i < 8; i++)  {
		OPT_SR_DAT = (data & 0b10000000) ? 1 : 0 ;
    	NOP() ;
		OPT_SR_CLK = 1 ;
    	NOP() ;
		OPT_SR_CLK = 0 ;

		data <<= 1 ;
	}
}
//	isr_SW_update() ;
{
	TRISB |= 0b00110110 ;
    NOP() ;
	OPT_SW_ACTIVATE = 0 ;

	__sw[0] = OPT_SW1 ;
	__sw[1] = OPT_SW2 ;
	__sw[2] = OPT_SEG1 ;
	__sw[3] = OPT_SEG2 ;
	__sw[4] = OPT_SEG3 ;
	__sw[5] = OPT_SEG4 ;

	OPT_SW_ACTIVATE = 1 ;

/*
	OPT_TRIS_SEG1 = 0 ;
	OPT_TRIS_SEG2 = 0 ;
	OPT_TRIS_SEG3 = 0 ;
	OPT_TRIS_SEG4 = 0 ;
*/
	TRISB &= ~0b00110110 ;
 }   	

	/* 1̕\f[^(ANeBuEj̏o */
//	isr_optShiftOut(~g7SEG[gDL]) ;
{
    data = ~g7SEG[gDL] ;
	for (i = 0; i < 8; i++)  {
		OPT_SR_DAT = (data & 0b10000000) ? 1 : 0 ;
    	NOP() ;
		OPT_SR_CLK = 1 ;
    	NOP() ;
		OPT_SR_CLK = 0 ;

		data <<= 1 ;
	}
}
	/* ỸRANeBu */
	switch (gDL++) {
		case 0:
			OPT_SEG1 = 0 ;
			break ;
		case 1:
			OPT_SEG2 = 0 ;
			break ;
		case 2:
			OPT_SEG3 = 0 ;
			break ;
		case 3:
			OPT_SEG4 = 0 ;
			break ;
	}
}


#else

/* 7ZOgLED̃_Ci~bN_\ */
/* gDLőΏۂƂȂĂ錅\ */
void
isr_SEG7_update()
{
	char i ;

    if (refreshSeg7 == 0)
        return ;
        
	/* \錅̊mF */
    if (gDL >= SEG7_DIGITS)
		gDL = 0 ;

	/* RׂĔANeBu */
	OPT_SEG1 = 1 ;
	NOP() ;
	OPT_SEG2 = 1 ;
	NOP() ;
	OPT_SEG3 = 1 ;
	NOP() ;
	OPT_SEG4 = 1 ;

	/* 1̕\f[^(ANeBuEj̏o */
	isr_optShiftOut(~g7SEG[gDL]) ;

	/* ỸRANeBu */
	switch (gDL++) {
		case 0:
			OPT_SEG1 = 0 ;
			break ;
		case 1:
			OPT_SEG2 = 0 ;
			break ;
		case 2:
			OPT_SEG3 = 0 ;
			break ;
		case 3:
			OPT_SEG4 = 0 ;
			break ;
	}
}

#endif

#else

/* 7ZOgLED̃_Ci~bN_\ */
/* gDLőΏۂƂȂĂ錅\ */
void
isr_SEG7_update()
{
	char i ;

    if (refreshSeg7 == 0)
        return ;
        
	/* \錅̊mF */
    if (gDL >= SEG7_DIGITS)
		gDL = 0 ;

	/* RׂĔANeBu */
    for (i = 0; i < SEG7_DIGITS; i++)
		isr_digitalWrite(segDigit[i], HIGH) ;

	/* 1̕\f[^(ANeBuEj̏o */
	isr_shiftOut(datPin, clkPin, MSBFIRST, ~g7SEG[gDL]) ;

	/* ỸRANeBu */
	isr_digitalWrite(segDigit[gDL++], LOW) ;
}

#endif

#endif