/***********************************************************

	pic16serial.c
	
	Version 0.90: 2009/10/16

	Copyright (C) 2007-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/

#include "picsys16.h"


#if defined(USE_SERIAL)

void
Serial_begin(long baud)
{
// lɐݒ
	TXSTA = 0x00 ;
	RCSTA = 0x00 ;
 
  // {[[gݒľvZƐݒ
#if _XTAL_FREQ < 10MHz
		BRGH = 1 ;
		SPBRG = _XTAL_FREQ / 16 / baud - 1 ;
#else
		SPBRG = _XTAL_FREQ / 64 / baud - 1 ;
#endif
 
	CREN = 1 ;	// pM

// M@\̋N
	TXEN = 1 ;
	SPEN = 1 ;
}


/***********************************************************
	Serial_end()
***********************************************************/

void
Serial_end()
{
// lɕA
	TXSTA = 0x00 ;
	RCSTA = 0x00 ;

// RCIE, TXIE: 荞݂̉
	PIE1 &= 0b11001111 ;
}


/***********************************************************
	Serial_puts(char *)
***********************************************************/

void
Serial_puts(char *s)
{
	while (*s) {
		while (Serial_busy())
			;
		Serial_write(*s++) ;
	}
}


/***********************************************************
	Serial_putrs(const char *)
***********************************************************/

void
Serial_putrs(const char *s)
{
	while (*s) {
		while (Serial_busy())
			;
		Serial_write(*s++) ;
	}
}

/***********************************************************
	Serial_puti(long n)
***********************************************************/

void
Serial_puti(long n)
{
    char *s ;

	ltoa(_fmtbuf, n, 10) ;
	
	s = _fmtbuf ;

	while (*s) {
		while (Serial_busy())
			;
		Serial_write(*s++) ;
	}
}

/***********************************************************
	Serial_putb(long n, byte base)
***********************************************************/

void
Serial_putb(long n, byte base)
{
    char *s ;

	ltoa(_fmtbuf, n, base) ;
	
	s = _fmtbuf ;

	while (*s) {
		while (Serial_busy())
			;
		Serial_write(*s++) ;
	}
}

#endif
