/***********************************************************

	pic16timer.c

	Version 0.90: 2009/10/16

	Copyright (C) 2007-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/

#include "picsys16.h"


static unsigned long millisec = 0 ;

unsigned long
millis()
{
	unsigned long t ;

	di() ;
	t = millisec ;
	ei() ;

	return t ;
}

void
delayMilliseconds(unsigned int t)
{
	unsigned long s, m ;

	di() ;
	s = millisec + t + 1 ;
	ei() ;

    do {
    	di() ;
    	m = millisec ;
    	ei() ;
    } while (m <= s) ;

	return ;
}

#if 0
void
delayMilliseconds(int t)
{
	for ( ; t > 0; t--)
		_delay(_XTAL_FREQ/4000UL) ;
}
#endif



/**********************************************************/


void
TIMER2_init()
{
	PR2 = (250 - 1) ;

	/* TCY / vXP[ / PR2 / 2KHz */
#if HEART_BEAT == 250Hz
	/* vXP[[1/16ɐݒA|XgXP[BBB */
	T2CON = 0b00000010 | ((_XTAL_FREQ / 4 / 16 / 250 / HEART_BEAT - 1) << 3) ;
#else
	/* vXP[[1/4ɐݒA|XgXP[BBB */
	T2CON = 0b00000001 | ((_XTAL_FREQ / 4 / 4 / 250 / HEART_BEAT - 1) << 3) ;
#endif

	TMR2IF = 0 ;
	TMR2IE = 1 ;
	PEIE = 1 ;
	GIE = 1 ;
	
	TMR2ON = 1 ;	// ^C}[X^[g
}


#ifdef	USE_SERVO
void
TIMER1_setup(int t)
{
	unsigned int tmr ;

	tmr = SERVO_NEUTRAL + t * SERVO_MINMAX ;
	tmr = tmr * (_XTAL_FREQ/(1MHz)/4) ;
	tmr = 65536 - tmr ;
	
//	T1CON = 0b00000000 ;
	
	TMR1H = tmr >> 8 ;
	TMR1L = tmr & 0xff ;
	
	TMR1IF = 0 ;
	TMR1IE = 1 ;
}
#endif


/**********************************************************/


extern byte _beepPin  ;
extern byte _beepValue ;

#if !(defined(PIC_PICO_2S) || defined(PIC_PICO_3S))
extern byte _pwmPin[] ;
extern byte _pwmValue[] ;

#ifdef	USE_SERVO
extern byte _servoPin[] ;
extern byte _servoDisable ;
extern int _servoValue[] ;
extern int _servoMin[] ;
extern int _servoMax[] ;

static byte __servoNum ;
#endif
#endif


/* 荞݃nh */
/* PIC16ł͑S荞ݗvɑ΂ănh͈ */
static void interrupt
isr()
{
	static byte n ;
	static byte sv = 0 ;
	byte i, tmp ;

#ifdef	USE_SERVO
	if (TMR1IF && TMR1IE) {	// T[{pX̏I
		isr_digitalWrite(_servoPin[__servoNum], LOW) ;
		/* 蓖ĂĂ΂̏ */
		if (_servoDisable & BIT(__servoNum)) {
			_servoPin[__servoNum] = NO_ASSIGN ;
			_servoDisable &= ~BIT(__servoNum) ;
		}

		TMR1IF = 0 ;
		TMR1IE = 0 ;
		TMR1ON = 0 ;
	}
#endif

	if (TMR2IF && TMR2IE) {	// TIMER2̊荞
		if (_beepPin != NO_ASSIGN)
			isr_digitalWrite(_beepPin, n & BIT(8 - _beepValue)) ;

		n++ ;

#if HEART_BEAT == 2000Hz
		if (n & 1) {
			millisec++ ;
			sv++ ;
		}

		if (sv >= 20)
			sv = 0 ;
#elif HEART_BEAT == 250Hz
		millisec += 4 ;
		sv += 5 ;	// CM[

		if (sv >= 25)	// CM[
			sv = 0 ;
#else
		millisec++ ;
		sv++ ;

		if (sv >= 20)
			sv = 0 ;
#endif

#if !(defined(PIC_PICO_2S) || defined(PIC_PICO_3S))
		/* PWM̃f[eB[ */
#if HEART_BEAT == 2000Hz
		i = n & 0b11111 ;
#elif HEART_BEAT == 250Hz
		i = n & 0b11 ;
#else
		i = n & 0b1111 ;
#endif

		if (_pwmPin[0] != NO_ASSIGN)
			isr_digitalWrite(_pwmPin[0], i > _pwmValue[0]) ;

		if (_pwmPin[1] != NO_ASSIGN)
			isr_digitalWrite(_pwmPin[1], i > _pwmValue[1]) ;

		if (_pwmPin[2] != NO_ASSIGN)
			isr_digitalWrite(_pwmPin[2], i > _pwmValue[2]) ;

		if (_pwmPin[3] != NO_ASSIGN)
			isr_digitalWrite(_pwmPin[3], i > _pwmValue[3]) ;

#ifdef USE_SERVO
		/* RCT[{̃pXJn */
		tmp = NO_ASSIGN ;
		if ((sv == 0) && (_servoPin[0] != NO_ASSIGN)) {
			tmp = 0 ;
		} else if ((sv == 5) && (_servoPin[1] != NO_ASSIGN)) {
			tmp = 1 ;
		} else if ((sv == 10) && (_servoPin[2] != NO_ASSIGN)) {
			tmp = 2 ;
		} else if ((sv == 15) && (_servoPin[3] != NO_ASSIGN)) {
			tmp = 3 ;
		}

		if (tmp != NO_ASSIGN) {
			__servoNum = tmp ;
//			TIMER1_setup(_servoValue[tmp]) ;
{
	unsigned int tmr ;

	tmr = SERVO_NEUTRAL + _servoValue[tmp] * SERVO_MINMAX ;
	tmr = tmr * (_XTAL_FREQ/(1MHz)/4) ;
	tmr = 65536 - tmr ;
	
//	T1CON = 0b00000000 ;
	
	TMR1H = tmr >> 8 ;
	TMR1L = tmr & 0xff ;
	
	TMR1IF = 0 ;
	TMR1IE = 1 ;
}

			isr_digitalWrite(_servoPin[tmp], HIGH) ;
			TMR1ON = 1 ;
		}
#endif
#endif

		/* 荞݂1/2ŕ\XV */
#ifdef USE_SEG7
#if HEART_BEAT == 250Hz
		isr_SEG7_update() ;
#else
	if ((n & 0b11) == 0)
		isr_SEG7_update() ;
#endif
#endif
#ifdef USE_DML
		if ((n & 0b1) == 0)
			isr_DML_update() ;
#endif
//		isrFunc() ;

		TMR2IF = 0 ;
	}
}
