/***********************************************************

	picsys16.c
	
	Version 0.90: 2009/10/16

	Copyright (C) 2007-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/


#include "picsys16.h"


/***********************************************************
	CONFIGݒ
***********************************************************/

#if defined(_16F886) || defined(_16F887)

#ifdef	XTAL_OSC
/*@NX^𗘗p */
__CONFIG(HS & LVPDIS & BORDIS & MCLREN & PWRTEN & WDTDIS) ;
#else
__CONFIG(INTIO & LVPDIS & BORDIS & MCLREN & PWRTEN & WDTDIS) ;
#endif
__CONFIG(BORV40) ;

#elif defined(_16F690)

#ifdef	XTAL_OSC
/*@NX^𗘗p */
__CONFIG(HS & BORDIS & MCLREN & PWRTEN & WDTDIS) ;
#else
/*@M𗘗p */
__CONFIG(INTIO & BORDIS & MCLREN & PWRTEN & WDTDIS) ;
#endif

#elif defined(_16F88)

#ifdef	XTAL_OSC
/*@NX^𗘗p */
__CONFIG(HS & LVPDIS & BORDIS & MCLRDIS & PWRTEN & WDTDIS) ;
__CONFIG(FCMEN) ;
#else
/*@M𗘗pAZbgsIO */
__CONFIG(INTIO & LVPDIS & BORDIS & MCLRDIS & PWRTEN & WDTDIS) ;
__CONFIG(FCMEN) ;
#endif

#elif defined(_16F628A) || defined(_16F627A)
/*@M𗘗pAZbgsIO */
__CONFIG(INTIO & LVPDIS & BORDIS & MCLRDIS & PWRTEN & WDTDIS) ;
#endif


/***********************************************************
	O[oϐ`
***********************************************************/

#if defined(_16F88)
static byte _adMap[] = {RA(0), RA(1), RA(2), RA(3), RA(4), RB(6), RB(7)} ;
#elif defined(_16F690)
static byte _adMap[] = {RA(0), RA(1), RA(2), RA(4), RC(0), RC(1), RC(2), RC(3),
		RC(6), RC(7), RB(4), RB(5)} ;
#elif defined(_16F886) || defined(_16F887)
static byte _adMap[] = {RA(0), RA(1), RA(2), RA(3), RA(5), NO_ASSIGN, NO_ASSIGN, NO_ASSIGN,
		RB(2), RB(3), RB(1), RB(4), RB(0), RB(5)} ;
#endif


byte _beepPin = NO_ASSIGN ;
byte _beepValue ;

#if !(defined(PIC_PICO_2S) || defined(PIC_PICO_3S))
byte _pwmPin[4] = {NO_ASSIGN, NO_ASSIGN, NO_ASSIGN, NO_ASSIGN } ;
byte _pwmValue[4] ;

#ifdef	USE_SERVO
byte _servoPin[4] = {NO_ASSIGN, NO_ASSIGN, NO_ASSIGN, NO_ASSIGN } ;
byte _servoDisable = 0x00 ;
int _servoValue[4] ;
int _servoMin[4] = {-100, -100, -100, -100} ;
int _servoMax[4] = {100, 100, 100, 100} ;
#endif
#endif


/***********************************************************
	VXȅ
***********************************************************/

void
initCore()
{
#if defined(_16F628A) || defined(_16F627A)
	/* AiORp[^̖ */
	CMCON = 0b00000111 ;
	RBPU = 0 ;
#endif

#if defined(_16F690) || defined(_16F886) || defined(_16F887)
#ifdef	INT_OSC
	OSCCON = 0b01110000 ;
#endif
#endif

#if defined(_16F88)
	ANSEL = 0b00000000 ;
	ADCON1 = 0b11000000 ;

    RBPU = 0 ;
//	WPUB = 0xff ;
#elif defined(_16F690)
	ANSEL = 0b00000000 ;
	ANSELH = 0b00000000 ;
	ADCON1 = 0b10000000 ;

	RABPU = 0 ;
//	WPUA = 0xff ;
//	WPUB = 0xff ;
#elif defined(_16F886) || defined(_16F887)
	ANSEL = 0b00000000 ;
	ANSELH = 0b00000000 ;
	ADCON1 = 0b10000000 ;

	RBPU = 0 ;
//	WPUB = 0xff ;
#endif
	
//	TIMER0_init() ;
	TIMER2_init() ;
}




void
main(void)
{
	initCore() ;

	setup() ;

	for (;;) {
		loop() ;
	}
}


/***********************************************************
	sI/O
***********************************************************/


void
pinMode(byte pin, byte mode)
{
	char i ;
	byte b ;

/* Ys̋@\ */
#if !(defined(_16F628A) || defined(_16F627A))
	/* AiO̖͂ */
	for (i = 0; i < sizeof(_adMap)/sizeof(byte); i++)
		if (_adMap[i] == pin) {
#if defined(_16F88)
			ANSEL &= ~BIT(i) ;
#elif defined(_16F690) || defined(_16F886) || defined(_16F887)
			if (i < 8)  {
				ANSEL &= ~BIT(i) ;
			} else {
				ANSELH &= ~BIT(i - 8) ;
			}
#endif
			break ;
		}
#endif

/* @\̉ */
	if (pin == _beepPin) {
		_beepPin = NO_ASSIGN ;
		digitalWrite(pin, LOW) ;
	}

#if !(defined(PIC_PICO_2S) || defined(PIC_PICO_3S))
	for (i = 0; i < sizeof(_pwmPin)/sizeof(byte); i++)
		if (_pwmPin[i] == pin)
			_pwmPin[i] = NO_ASSIGN ;

#ifdef USE_SERVO
	for (i = 0; i < sizeof(_servoPin)/sizeof(byte); i++)
		if (_servoPin[i] == pin) {
			_servoDisable |= BIT(i) ;
		}
#endif
#endif

/* Ys̋@\̍ĐݒJn */
	if (mode >= 2) {
		i = mode & 0b11 ;
		
		if (mode == OUT_BEEP) {
			_beepPin = pin ;
			_beepValue = 0 ;
			digitalWrite(pin, LOW) ;
#if !(defined(PIC_PICO_2S) || defined(PIC_PICO_3S))
		} else if (isPWM(mode)) {
			_pwmPin[i] = pin ;
			_pwmValue[i] = 0 ;
#ifdef USE_SERVO
		} else if (isSERVO(mode)) {
			_servoPin[i] = pin ;
			_servoValue[i] = 0 ;
#endif
#endif
		}
		
		mode = OUTPUT ;
	}

	/* ws̑ΉrbgZo */
	b = BIT(pin & 0b00000111) ;

	/* ws̓o̓[hݒ */
	switch (pin >> 3) {
		case ID_PORTA: // PORTA
			if (mode == OUTPUT) {
				TRISA &= ~b ;
			} else {
				TRISA |= b ;
			}
			break ;		

		case ID_PORTB: // PORTB
			if (mode == OUTPUT) {
				TRISB &= ~b ;
			} else {
				TRISB |= b ;
			}
			break ;		

#if defined(_16F690) || defined(_16F886) || defined(_16F887)
		case ID_PORTC: // PORTC
			if (mode == OUTPUT) {
				TRISC &= ~b ;
			} else {
				TRISC |= b ;
			}
			break ;		
#endif

#if defined(_16F886) || defined(_16F887)
		case ID_PORTE: // PORTE
			if (mode == OUTPUT) {
				TRISE &= ~b ;
			} else {
				TRISE |= b ;
			}
			break ;		
#endif
		default:
			break ;
	}
}


void
digitalWrite(byte pin, int value)
{
	char i ;
	byte b ;
	
	if (pin == _beepPin) {
		if (value > 8)
			_beepValue = 8 ;
		else if (value < 0)
			_beepValue = 0 ;
		else
			_beepValue = value ;
		
		return ;
	}

#if !(defined(PIC_PICO_2S) || defined(PIC_PICO_3S))
	for (i = 0; i < sizeof(_pwmPin)/sizeof(byte); i++)
		if (_pwmPin[i] == pin) {
#if HEART_BEAT == 2000Hz
			_pwmValue[i] = (value >> 3) & 0b11111 ;
#elif HEART_BEAT == 250Hz
			_pwmValue[i] = (value >> 6) & 0b11 ;
#else
			_pwmValue[i] = (value >> 4) & 0b1111 ;
#endif
			return ;
		}

#ifdef USE_SERVO
	for (i = 0; i < sizeof(_servoPin)/sizeof(byte); i++)
		if (_servoPin[i] == pin) {
			if (value > _servoMax[i])
				_servoValue[i] = _servoMax[i] ;
			else if (value < _servoMin[i])
				_servoValue[i] = _servoMin[i] ;
			else
				_servoValue[i] = value ;

			return ;
		}
#endif
#endif

	/* ws̑ΉrbgZo */
	b = BIT(pin & 0b00000111) ;

	/* wsɒlo */
	switch (pin >> 3) {
		case ID_PORTA: // PORTA
			if (value == 0) {
				PORTA &= ~b ;
			} else {
				PORTA |= b ;
			}
			break ;		

		case ID_PORTB: // PORTB
			if (value == 0) {
				PORTB &= ~b ;
			} else {
				PORTB |= b ;
			}
			break ;		

#if defined(_16F690) || defined(_16F886) || defined(_16F887)
		case ID_PORTC: // PORTC
			if (value == 0) {
				PORTC &= ~b ;
			} else {
				PORTC |= b ;
			}
			break ;		
#endif

#if defined(_16F886) || defined(_16F887)
		case ID_PORTE: // PORTE
			if (value == 0) {
				PORTE &= ~b ;
			} else {
				PORTE |= b ;
			}
			break ;		
#endif
		default:
			break ;
	}
}


byte
digitalRead(byte pin)
{
	byte b ;

	/* ws|[g̓ǂݏo */
	switch (pin >> 3) {
		case ID_PORTA: // PORTA
			b = PORTA ;
			break ;		

		case ID_PORTB: // PORTB
			b = PORTB ;
			break ;		

#if defined(_16F690) || defined(_16F886) || defined(_16F887)
		case ID_PORTC: // PORTC
			b = PORTC ;
			break ;		
#endif

#if defined(_16F886) || defined(_16F887)
		case ID_PORTE: // PORTE
			b = PORTE ;
			break ;		
#endif
		default:
			break ;
	}

	/* ws̓͒l擾 */
	return 1 & (b >> (pin & 0b00000111)) ;
}


#if !(defined(PIC_GAME_2SX) || defined(PIC_PICO_2S) || defined(PIC_PICO_3S))
void
shiftOut(byte data, byte clock, byte order, byte value)
{
	byte b, i, v ;

	for (i = 0; i < 8; i++)  {
		v = value & ((order == LSBFIRST) ? 1 : 0b10000000) ;

		b = (1 << (data & 0b00000111)) ;

		switch (data >> 3) {
			case ID_PORTA: // PORTA
				if (v == 0) {
					PORTA &= ~b ;
				} else {
					PORTA |= b ;
				}
				break ;		

			case ID_PORTB: // PORTB
				if (v == 0) {
					PORTB &= ~b ;
				} else {
					PORTB |= b ;
				}
				break ;		

#if defined(_16F690) || defined(_16F886) || defined(_16F887)
			case ID_PORTC: // PORTC
				if (v == 0) {
					PORTC &= ~b ;
				} else {
					PORTC |= b ;
				}
				break ;		
#endif

#if defined(_16F886) || defined(_16F887)
			case ID_PORTE: // PORTE
				if (v == 0) {
					PORTE &= ~b ;
				} else {
					PORTE |= b ;
				}
				break ;		
#endif
			default:
				break ;
		}

		b = (1 << (clock & 0b00000111)) ;

		switch (clock >> 3) {
			case ID_PORTA: // PORTA
				PORTA |= b ;
				PORTA &= ~b ;
				break ;		

			case ID_PORTB: // PORTB
				PORTB |= b ;
				PORTB &= ~b ;
				break ;		

#if defined(_16F690) || defined(_16F886) || defined(_16F887)
			case ID_PORTC: // PORTC
				PORTC |= b ;
				PORTC &= ~b ;
				break ;		
#endif

#if defined(_16F886) || defined(_16F887)
			case ID_PORTE: // PORTE
				PORTE |= b ;
				PORTE &= ~b ;
				break ;		
#endif
			default:
				break ;
		}

		if (order == LSBFIRST)
			value >>= 1 ;
		else
			value <<= 1 ;
	}
}
#endif


#if !(defined(_16F628A) || defined(_16F627A))

static byte _vref = 0 ;

int
analogRead(byte pin)
{
	byte p ;
	
	if (!isAN(pin))
		return 0 ;

	/* LȃAiOsH */
	if ((p = _adMap[pin]) == NO_ASSIGN)
		return 0 ;

	/* AiOsnCCs[_X */
	pinMode(p, INPUT) ;

	/* ỸAiOsL */
	if (pin < 8)  {
		ANSEL |= (1 << pin) ;
#if !defined(_16F88)
	} else {
		ANSELH |= (1 << (pin - 8)) ;
#endif
	}

#if defined(_16F88)
	// ADFM, CHS, ADON
	ADCON0 = 0b10000001 | (pin << 3) ;
#elif defined(_16F690)
	// ADFM, VCFG, CHS, ADON
	ADCON0 = 0b10000001 | (pin << 2) ;
	// ADCS
	ADCON1 = 0b01100000 ;
#elif defined(_16F886) || defined(_16F887)
	// ADCS, CHS, ADON
	ADCON0 = 0b10000001 | (pin << 2) ;
	// ADFM, VCFG0, VCFG1
	ADCON1 = 0b10000000 ;
#endif
	delayMicroseconds(10) ;

	GODONE = 1 ;

	while (GODONE)
		;

	return (ADRESH << 8) + ADRESL ;
}


void
analogReference(byte type)
{
	pinMode(_adMap[AN(3)], INPUT) ;

	if (type == DEFAULT)
		_vref = 0 ;
	else if (type == EXTERNAL)
		_vref = 0b00010000 ;
}

#endif

/************************************************/

#if 0
void
isr_pinMode(byte pin, byte mode)
{
	char i ;
	byte b ;

	for (i = 0; i < sizeof(_adMap)/sizeof(char); i++)
		if (_adMap[i] == pin) {
#if defined(_16F88)
			ANSEL &= ~(1 << i) ;
#elif defined(_16F690) || defined(_16F886) || defined(_16F887)
			if (i < 8)  {
				ANSEL &= ~(1 << i) ;
			} else {
				ANSELH &= ~(1 << (i - 8)) ;
			}
#endif
			break ;
		}

	b = (1 << (pin & 0b00000111)) ;

	switch (pin >> 3) {
		case ID_PORTA: // PORTA
			if (mode == OUTPUT) {
				TRISA &= ~b ;
			} else {
				TRISA |= b ;
			}
			break ;		

		case ID_PORTB: // PORTB
			if (mode == OUTPUT) {
				TRISB &= ~b ;
			} else {
				TRISB |= b ;
			}
			break ;		

#if defined(_16F690) || defined(_16F886) || defined(_16F887)
		case ID_PORTC: // PORTC
			if (mode == OUTPUT) {
				TRISC &= ~b ;
			} else {
				TRISC |= b ;
			}
			break ;		
#endif

#if defined(_16F886) || defined(_16F887)
		case ID_PORTE: // PORTE
			if (mode == OUTPUT) {
				TRISE &= ~b ;
			} else {
				TRISE |= b ;
			}
			break ;		
#endif
		default:
			break ;
	}
}

#endif


void
isr_digitalWrite(byte pin, int value)
{
	byte b = (1 << (pin & 0b00000111)) ;

	switch (pin >> 3) {
		case ID_PORTA: // PORTA
			if (value == 0) {
				PORTA &= ~b ;
			} else {
				PORTA |= b ;
			}
			break ;		

		case ID_PORTB: // PORTB
			if (value == 0) {
				PORTB &= ~b ;
			} else {
				PORTB |= b ;
			}
			break ;		

#if defined(_16F690) || defined(_16F886) || defined(_16F887)
		case ID_PORTC: // PORTC
			if (value == 0) {
				PORTC &= ~b ;
			} else {
				PORTC |= b ;
			}
			break ;		
#endif

#if defined(_16F886) || defined(_16F887)
		case ID_PORTE: // PORTE
			if (value == 0) {
				PORTE &= ~b ;
			} else {
				PORTE |= b ;
			}
			break ;		
#endif
		default:
			break ;
	}
}


#if 0

void
isr_shiftOut(byte data, byte clock, byte order, byte value)
{
	byte b, i, v ;

	for (i = 0; i < 8; i++)  {
		v = value & ((order == LSBFIRST) ? 1 : 0b10000000) ;

		b = (1 << (data & 0b00000111)) ;

		switch (data >> 3) {
			case ID_PORTA: // PORTA
				if (v == 0) {
					PORTA &= ~b ;
				} else {
					PORTA |= b ;
				}
				break ;		

			case ID_PORTB: // PORTB
				if (v == 0) {
					PORTB &= ~b ;
				} else {
					PORTB |= b ;
				}
				break ;		

#if defined(_16F690) || defined(_16F886) || defined(_16F887)
			case ID_PORTC: // PORTC
				if (v == 0) {
					PORTC &= ~b ;
				} else {
					PORTC |= b ;
				}
				break ;		
#endif

#if defined(_16F886) || defined(_16F887)
			case ID_PORTE: // PORTE
				if (v == 0) {
					PORTE &= ~b ;
				} else {
					PORTE |= b ;
				}
				break ;		
#endif
			default:
				break ;
		}

		b = (1 << (clock & 0b00000111)) ;

		switch (clock >> 3) {
			case ID_PORTA: // PORTA
				PORTA |= b ;
				PORTA &= ~b ;
				break ;		

			case ID_PORTB: // PORTB
				PORTB |= b ;
				PORTB &= ~b ;
				break ;		

#if defined(_16F690) || defined(_16F886) || defined(_16F887)
			case ID_PORTC: // PORTC
				PORTC |= b ;
				PORTC &= ~b ;
				break ;		
#endif

#if defined(_16F886) || defined(_16F887)
			case ID_PORTE: // PORTE
				PORTE |= b ;
				PORTE &= ~b ;
				break ;		
#endif
			default:
				break ;
		}

		if (order == LSBFIRST)
			value >>= 1 ;
		else
			value <<= 1 ;
	}
}

#endif

#ifndef PIC_PICO_3S

#ifdef	OPTIMIZE

void
isr_optShiftOut(byte value)
{
	byte i ;

	for (i = 0; i < 8; i++)  {
		OPT_SR_DAT = (value & 0b10000000) ? 1 : 0 ;
		NOP() ;
		OPT_SR_CLK = 1 ;
		NOP() ;
		OPT_SR_CLK = 0 ;

		value <<= 1 ;
	}
}

#endif
#endif
