/***********************************************************

	picsys16.h

	Version 0.90: 2009/10/16

	Copyright (C) 2007-2009, MicroFan Div., PeopleMedia, Inc.
	All rights reserved.

***********************************************************/


#ifndef PICSYS16_H_
#define PICSYS16_H_

#include <htc.h>
#include <stdlib.h>
#include <string.h>

#define	MHz	*1000000UL
#define	Hz	*1UL

#include "picsys16conf.h"


#if defined(PIC_PICO_2S) || defined(PIC_PICO_3S)
#undef	XTAL_OSC
#undef	INT_OSC
#define	INT_OSC	4MHz
#endif

#if defined(XTAL_OSC)
#define	_XTAL_FREQ	XTAL_OSC
#elif defined(INT_OSC)
#define	_XTAL_FREQ	INT_OSC
#else
#error MƎg̎w肪܂
#endif

#ifdef	USE_SERVO
#define	HEART_BEAT	250Hz
#else
#if _XTAL_FREQ >= 16MHz
#define	HEART_BEAT	2000Hz
#else
#define	HEART_BEAT	1000Hz
#endif
#endif


/************************************************/

#define	TRUE	1
#define	FALSE	0

#define	HIGH	1
#define	LOW		0

typedef unsigned char byte ;

#define	BIT(n)	(0b00000001 << (n))

/*------------------------------------------------
	i/O|[g̒`
------------------------------------------------*/

#define	ID_ANL	0
#define	ID_ANH	1
#define	ID_PORTA	2
#define	ID_PORTB	3
#define	ID_PORTC	4
#define	ID_PORTD	5
#define	ID_PORTE	6
#define	ID_VSW	7

#define	ID_X(id)	(id << 3)

#define	isAN(pin)	((pin & 0b110000) == 0b000000)

#define	AN(pin)	(pin)

#define	RA(pin)	(ID_X(ID_PORTA) | pin)
#define	RB(pin)	(ID_X(ID_PORTB) | pin)
#define	RC(pin)	(ID_X(ID_PORTC) | pin)
#define	RD(pin)	(ID_X(ID_PORTD) | pin)
#define	RE(pin)	(ID_X(ID_PORTE) | pin)

#define	NO_ASSIGN	0xff


/*------------------------------------------------
	s[h̒`
------------------------------------------------*/

#define	INPUT	1
#define	OUTPUT	0
#define	OUT_BEEP	2
#define	OUT_PWM1	0b1000
#define	OUT_PWM2	0b1001
#define	OUT_PWM3	0b1010
#define	OUT_PWM4	0b1011
#define	OUT_SERVO1	0b1100
#define	OUT_SERVO2	0b1101
#define	OUT_SERVO3	0b1110
#define	OUT_SERVO4	0b1111

#define	isPWM(mode)	((mode & 0b1100) == 0b1000)
#define	isSERVO(mode)	((mode & 0b1100) == 0b1100)

void pinMode(byte, byte) ;
void digitalWrite(byte, int) ;
byte digitalRead(byte) ;

#define	MSBFIRST	1
#define	LSBFIRST	0

void shiftOut(byte, byte, byte, byte) ;

int analogRead(byte) ;
void analogReference(byte) ;

#define	DEFAULT	0
#define	EXTERNAL	1

/************************************************/

void delayMilliseconds(unsigned int) ;
// #define delayMicroseconds(us) _delay((unsigned long)((us)*(_XTAL_FREQ/40000000UL)))
#define delayMicroseconds(us) __delay_us(us)

unsigned long millis() ;


/************************************************/

extern char _fmtbuf[] ;
// int ltoa(char [], long, int) ;

/************************************************/

void setup() ;
void loop() ;

// void isrFunc() ;
void initCore() ;


/************************************************/

#ifdef OPTIMIZE
void isr_optShiftOut(byte) ;
#endif

void isr_pinMode(byte, byte) ;
void isr_digitalWrite(byte, int) ;
byte isr_digitalRead(byte) ;
void isr_shiftOut(byte, byte, byte, byte) ;


/************************************************/

#define	SERVO_NEUTRAL	1500
#define	SERVO_MINMAX	5

#ifdef	USE_SERVO

#ifdef USE_DML
#undef USE_DML
#endif

#endif


/************************************************/

#ifdef PIC_DEV_886RL

#if !(defined(_16F886) || defined(_16F887))
#error MCU`bv̐ݒ肪ԈĂ܂
#endif

#include "..\BOARD\pic-dev-886rl.h"

#ifndef USE_SERIAL
#define	USE_SERIAL
#endif

#endif

#ifdef PIC_DEV_690RL
#if !(defined(_16F690))
#error MCU`bv̐ݒ肪ԈĂ܂
#endif

#include "..\BOARD\pic-dev-690rl.h"

#ifndef USE_SERIAL
#define	USE_SERIAL
#endif

#endif

#ifdef PIC_7SEG_88
#if !defined(_16F88)
#error MCU`bv̐ݒ肪ԈĂ܂
#endif

#include "..\BOARD\pic-7seg-88.h"

#ifndef USE_SEG7
#define USE_SEG7
#endif

#ifdef USE_DML
#undef	USE_DML
#endif

#ifdef USE_CLCD
#undef USE_CLCD
#endif

#ifdef USE_SERIAL
#undef USE_SERIAL
#endif

#endif

#ifdef PIC_GAME_2SX
#if !(defined(_16F886) || defined(_16F887))
#error MCU`bv̐ݒ肪ԈĂ܂
#endif

#include "..\BOARD\pic-game-2sx.h"

#ifndef USE_DML
#define	USE_DML
#endif

#ifdef USE_CLCD
#undef USE_CLCD
#endif

#ifdef USE_SEG7
#undef USE_SEG7
#endif

#ifdef USE_SERIAL
#undef USE_SERIAL
#endif

#endif

#ifdef PIC_PICO_2S
#if !(defined(_16F628A) || defined(_16F627A))
#error MCU`bv̐ݒ肪ԈĂ܂
#endif

#include "..\BOARD\pic-pico-2s.h"

#ifndef USE_DML
#define	USE_DML
#endif

#ifdef USE_CLCD
#undef USE_CLCD
#endif

#ifdef USE_SEG7
#undef USE_SEG7
#endif

#ifdef USE_SERIAL
#undef USE_SERIAL
#endif

#ifdef USE_SERVO
#undef USE_SERVO
#endif

#endif

#ifdef PIC_PICO_3S
#if !(defined(_16F628A) || defined(_16F627A))
#error MCU`bv̐ݒ肪ԈĂ܂
#endif

#include "..\BOARD\pic-pico-3s.h"

#ifndef USE_SEG7
#define USE_SEG7
#endif

#ifdef USE_DML
#undef USE_DML
#endif

#ifdef USE_CLCD
#undef USE_CLCD
#endif

#ifdef USE_SERIAL
#undef USE_SERIAL
#endif

#ifdef USE_SERVO
#undef USE_SERVO
#endif

#endif

/************************************************/

#include "pic16timer.h"
#include "pic16clcd.h"
#include "pic16seg7.h"
#include "pic16dml.h"
#include "pic16serial.h"


#endif /*PICSYS16_H_*/
